<template>
  <div class="userManger-page">
    <a-table :columns="columns" :data-source="columnsData" :loading="loading" rowKey="user_id">
      <template slot="status" slot-scope="text, record">
        <a-tag :color="record.black == 0 ? 'green' : 'red'">{{record.black == 0 ? '已激活' : '已禁用'}}</a-tag>
      </template>
      <template slot="operation" slot-scope="text, record, index">
        <span v-if="record.user_type == 'admin'">-</span>
        <a class="action" v-else @click="handleClick(record, index)" :class="{'disabled': record.black == 0}">{{record.black == 0 ? '禁用' : '激活'}}</a>
      </template>
    </a-table>
  </div>
</template>

<script>
export default {
  name: "userManger",

  data() {
    return {
      columns: [
        {
          title: '用户ID',
          dataIndex: 'user_id',
          key: 'user_id'
        },{
          title: '用户名',
          dataIndex: 'user_name',
          key: 'user_name'
        },{
          title: '手机号',
          dataIndex: 'phone',
          key: 'phone'
        },{
          title: '邮箱',
          dataIndex: 'mail',
          key: 'mail'
        },{
          title: '状态',
          dataIndex: 'status',
          key: 'status',
          scopedSlots: { customRender: 'status' },
        },{
          title: '操作',
          dataIndex: 'operation',
          key: 'operation',
          scopedSlots: { customRender: 'operation' },
        },
      ],
      columnsData: [],
      loading: false
    };
  },

  created() {
    this.getList()
  },

  methods: {
    async getList() {
      this.loading = true
      await this.$axios.get('user/query').then(res => {
        if (res.code == undefined) {
          this.columnsData = res
        }
      }).catch(() => {})
      this.loading = false
    },

    handleClick(record, index) {
      let url = ''
      if (record.black == 0) {
        url = 'user/disable'
      } else {
        url = 'user/open'
      }
      this.$axios.post(url, {
        user_id: record.user_id
      }).then(res => {
        if (res.code == 0) {
          if (record.black == 0) {
            this.$notification.success({
              message: '用户禁用成功'
            })
            this.columnsData[index].black = 1
          } else {
            this.$notification.success({
              message: '用户激活成功'
            })
            this.columnsData[index].black = 0
          }
        } else {
          if (record.black == 0) {
            this.$notification.error({
              message: '用户禁用失败'
            })
          } else {
            this.$notification.error({
              message: '用户激活失败'
            })
          }
        }
      }).catch(() => {
        if (record.black == 0) {
          this.$notification.error({
            message: '用户禁用失败'
          })
        } else {
          this.$notification.error({
            message: '用户激活失败'
          })
        }
      })
    }
  }
}
</script>

<style lang="less" scoped>
.action {
  &.disabled {
    color: #ff3434;
  }
}
</style>